/*
 * dl_auth.h
 *
 * Copyright (C) 2019		Denovolab Ltd.
 * 				Andrew Clayton <andrew@zeta.digital-domain.net>
 */

#ifndef _DL_AUTH_H_
#define _DL_AUTH_H_

#include <stdbool.h>

#ifdef __cplusplus
extern "C" {
#endif

#define LIBDLAUTH_MAJOR_VERSION		0
#define LIBDLAUTH_MINOR_VERSION		0
#define LIBDLAUTH_MICRO_VERSION		0

enum dl_auth_error {
	DL_AUTH_ERR_NONE = 0,
	DL_AUTH_ERR_AUTH_ERR,
	DL_AUTH_ERR_DB_ERR,
	DL_AUTH_ERR_SQL_ERR,
	DL_AUTH_ERR_NO_AUTH,
	DL_AUTH_ERR_EXPIRED
};

enum dl_auth_error_reason {
	DL_AUTH_ERR_REASON_NONE = 0,
	DL_AUTH_ERR_REASON_CONF_DIR,
	DL_AUTH_ERR_REASON_CONFIG,
	DL_AUTH_ERR_REASON_JWT_CREATE,
	DL_AUTH_ERR_REASON_JWT_DECODE,
	DL_AUTH_ERR_REASON_JWT_ALG,
	DL_AUTH_ERR_REASON_CONNECT,
	DL_AUTH_ERR_REASON_TLS_INIT,
	DL_AUTH_ERR_REASON_TLS_CONNECT
};

#pragma GCC visibility push(default)

extern int dl_auth_check(const char *conf_dir, bool always_check);

extern const char *dl_auth_err2str(int error);
extern const char *dl_auth_error_reason_str(void);

#pragma GCC visibility pop

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _DL_AUTH_H_ */
