# libdlauth
## Overview

This is a library for doing authorisations for use in some of our applications
where we may want to put certain restrictions on their use.

It does this by sending some information to a server (dlauthd) using a JSON
Web Token. The server can then decide if to authorise the client or not and
send the result back to the client again using a JSON Web Token.

## Building

First clone this repository someplace

    $ git clone http://stash.denovolab.com/scm/~clayton/libdlauth.git

libdlauth has a few dependencies

    jansson, libjwt & OpenSSL

On Red Hat/Fedora based distributions, jansson and OpenSSL can be installed
via yum|dnf e.g

    $ sudo dnf install jansson-devel openssl-devel

libjwt is currently not packaged but can be built/packaged/installed with

    $ mkdir -p ~/rpmbuild/{BUILD,RPMS,SOURCES,SPECS,SRPMS}

    $ git clone https://github.com/benmcollins/libjwt.git
    $ cd libjwt
    $ git archive --prefix=libjwt-1.10.1/ -o ~/rpmbuild/SOURCES/libjwt-1.10.1.tar v1.10.1
    $ rpmbuild -bb ../libdlauth/misc/libjwt.spec
    $ sudo dnf install ~/rpmbuild/RPMS/x86_64/libjwt-1.10.1-1.*.x86_64.rpm

    $ cd ../libdlauth
    $ make

## Use

libdlauth requires a few files to operate; conf.json, user.json, examples
of which can be found in config/.

For conf.json set *server* & *port* to that of where dlauthd is running. See
below for the cafile setting.

user.json should be generated automatically using the *curl* command as
described in README.server.

It also requires a TLS certificate file, this is the same file as specified
by the tls.cert setting in the dlauthd & dlauthadmd config files. If you have
a *real* certificate use that, or you can create one using the openssl command
from README.server.

These three files should be placed someplace (more files will be added to
this location by the library itself). On Linux, ~/.config/dl\_auth might be
a good choice.

There is a simple test wrapper at src/lib/test/test, this can be run with the
test.sh script (it sets the LD\_LIBRARY\_PRELOAD path), e.g

    $ ./test.sh /path/to/config/dir

## Contributing

See *CodingStyle.md* & *Contributing.md*
